Subject: bug#77086: Filesystems not unmounted on reboot

From: Ludovic Courtès <[email-masked]>
Date: Tue, 01 Apr 2025 09:25:09 +0200

Hi,

Rutherther <[email-masked]> skribis:

> I was testing on commmit Ian sent to reproduce, and now moved to
> newest guix, seems to have been solved (at least the specific error I
> was getting),
> possibly by shepherd 1.0.3 update.
>
> With newest guix both the first reconfigure of guix system image
> and subsequent ones are fine.

I believe I’m still experiencing it on my laptop (but it’s harmless, I
only briefly see e2fsck saying “recovering journal” at boot time), but
of course, not the slightest clue in /var/log/messages.

> Let me know if you're still experiencing this issue after updating
> and I might try harder to reproduce if I got a different issue on first
> try. I am afraid this will be hard to debug on real hw as you don't
> really get the log in /var/log/messages for shutting down the system, I
> had to get it through a serial line via stdout of qemu.
>
> Also I was able to reproduce the issue on the older
> guix just by running the shepherd services upgrade scm script,
> no need for full reconfigure, this shows that something has gone
> wrong when shepherd was reloading the services. Do we have some kind of
> a test for this in guix / shepherd so it can't happen anymore in the future?

There’s a system test, “root-unmount” in (gnu tests base), but it
succeeds: <https://ci.guix.gnu.org/build/9790935/details>.

Perhaps the problem only shows up with more complex system configs?
My root partition is on a LUKS device, but I think the problem is more
something like EBUSY upon ‘umount’ due to stale processes.

Thanks,
Ludo’.